#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <stdarg.h>

#include "signature.h"
#include "patcher.h"
#include "types.h"

using namespace std;

game_info_t game_info = {
  1,
  {
    { "6.rom", // 9th Nov. 1993
      0x80000, /* ROM size */
      0xCA348CAF, /* ROM CRC */
      0,
    },
  },
};

void patch_6rom()
{
  uint32_t patch0_addr = 0x00000002;
  uint8_t patch0_data[] = {
    0x20, 
  };
  APPLY_PATCH(0);

  uint32_t patch1_addr = 0x00006AFA;
  uint8_t patch1_data[] = {
    0x80, 0x7E, 0x14, 
  };
  APPLY_PATCH(1);

  uint32_t patch2_addr = 0x00006AFE;
  uint8_t patch2_data[] = {
    0x0C, 0x60, 
  };
  APPLY_PATCH(2);

  uint32_t patch3_addr = 0x0000B026;
  uint8_t patch3_data[] = {
    0x80, 0x70, 0x14, 
  };
  APPLY_PATCH(3);

  uint32_t patch4_addr = 0x0000B02A;
  uint8_t patch4_data[] = {
    0x16, 0x60, 
  };
  APPLY_PATCH(4);

  uint32_t patch5_addr = 0x0000BF4A;
  uint8_t patch5_data[] = {
    0x80, 0x70, 0x14, 
  };
  APPLY_PATCH(5);

  uint32_t patch6_addr = 0x0000BF4E;
  uint8_t patch6_data[] = {
    0x16, 0x60, 
  };
  APPLY_PATCH(6);

  uint32_t patch7_addr = 0x0000BF64;
  uint8_t patch7_data[] = {
    0x76, 0x46, 0x65, 0x4E, 0x75, 0x29, 0xB6, 0x46, 0x72, 0x4E, 0x76, 0x46, 0x6D, 0x4E, 0x75, 0x29, 
    0xB6, 0x46, 0x75, 0x4E, 
  };
  APPLY_PATCH(7);

  uint32_t patch8_addr = 0x0000C194;
  uint8_t patch8_data[] = {
    0x69, 0x30, 
  };
  APPLY_PATCH(8);

  uint32_t patch9_addr = 0x0000CA26;
  uint8_t patch9_data[] = {
    0xB9, 0x2F, 0xE4, 0xEA, 0x08, 0x05, 0x51, 0xA4, 
  };
  APPLY_PATCH(9);

  uint32_t patch10_addr = 0x0000CA72;
  uint8_t patch10_data[] = {
    0xC0, 0x04, 0x1B, 
  };
  APPLY_PATCH(10);

  uint32_t patch11_addr = 0x0000CA76;
  uint8_t patch11_data[] = {
    0x30, 0xF0, 
  };
  APPLY_PATCH(11);

  uint32_t patch12_addr = 0x0000CAD2;
  uint8_t patch12_data[] = {
    0x40, 
  };
  APPLY_PATCH(12);

  uint32_t patch13_addr = 0x0000CAEE;
  uint8_t patch13_data[] = {
    0x40, 
  };
  APPLY_PATCH(13);

  uint32_t patch14_addr = 0x0000CB08;
  uint8_t patch14_data[] = {
    0x40, 
  };
  APPLY_PATCH(14);

  uint32_t patch15_addr = 0x0000CBFA;
  uint8_t patch15_data[] = {
    0xC4, 
  };
  APPLY_PATCH(15);

  uint32_t patch16_addr = 0x0000CC22;
  uint8_t patch16_data[] = {
    0xD8, 
  };
  APPLY_PATCH(16);

  uint32_t patch17_addr = 0x0000CC38;
  uint8_t patch17_data[] = {
    0xD8, 
  };
  APPLY_PATCH(17);

  uint32_t patch18_addr = 0x0000FE4E;
  uint8_t patch18_data[] = {
    0xB9, 0x2F, 0x7E, 0xB0, 0x10, 
  };
  APPLY_PATCH(18);

  uint32_t patch19_addr = 0x0000FE54;
  uint8_t patch19_data[] = {
    0x0D, 0xFA, 
  };
  APPLY_PATCH(19);

  uint32_t patch20_addr = 0x00046000;
  uint8_t patch20_data[] = {
    0xC3, 0xB5, 0xF2, 0xB0, 0x79, 0x0A, 0xFF, 0xFF, 0x1F, 
  };
  APPLY_PATCH(20);

  uint32_t patch21_addr = 0x0004600A;
  uint8_t patch21_data[] = {
    0xF0, 0xFF, 0x39, 0x30, 0x10, 
  };
  APPLY_PATCH(21);

  uint32_t patch22_addr = 0x00046010;
  uint8_t patch22_data[] = {
    0x08, 
  };
  APPLY_PATCH(22);

  uint32_t patch23_addr = 0x00046012;
  uint8_t patch23_data[] = {
    0x75, 0x4E, 0x39, 0x3E, 0x10, 
  };
  APPLY_PATCH(23);

  uint32_t patch24_addr = 0x00046018;
  uint8_t patch24_data[] = {
    0x02, 
  };
  APPLY_PATCH(24);

  uint32_t patch25_addr = 0x0004601A;
  uint8_t patch25_data[] = {
    0x79, 0x4A, 0x1F, 
  };
  APPLY_PATCH(25);

  uint32_t patch26_addr = 0x0004601E;
  uint8_t patch26_data[] = {
    0xF0, 0xFF, 0x02, 0x6A, 0x75, 0x4E, 0x07, 0x08, 0x06, 
  };
  APPLY_PATCH(26);

  uint32_t patch27_addr = 0x00046028;
  uint8_t patch27_data[] = {
    0x04, 0x66, 0x87, 0x08, 0x04, 
  };
  APPLY_PATCH(27);

  uint32_t patch28_addr = 0x0004602E;
  uint8_t patch28_data[] = {
    0x07, 0x08, 0x0E, 
  };
  APPLY_PATCH(28);

  uint32_t patch29_addr = 0x00046032;
  uint8_t patch29_data[] = {
    0x04, 0x66, 0x87, 0x08, 0x0C, 
  };
  APPLY_PATCH(29);

  uint32_t patch30_addr = 0x00046038;
  uint8_t patch30_data[] = {
    0x75, 0x4E, 
  };
  APPLY_PATCH(30);

  uint32_t patch31_addr = 0x0004603C;
  uint8_t patch31_data[] = {
    0x07, 0x08, 0x03, 
  };
  APPLY_PATCH(31);

  uint32_t patch32_addr = 0x00046040;
  uint8_t patch32_data[] = {
    0x06, 0x67, 0x79, 0x4A, 0x1F, 
  };
  APPLY_PATCH(32);

  uint32_t patch33_addr = 0x00046046;
  uint8_t patch33_data[] = {
    0x0C, 0x90, 0x75, 0x4E, 
  };
  APPLY_PATCH(33);

  uint32_t patch34_addr = 0x0004604C;
  uint8_t patch34_data[] = {
    0x54, 0x53, 0x47, 0x41, 0x20, 0x45, 0x20, 0x20, 0x20, 0x20, 0x31, 0x20, 0x2F, 0x20, 0x38, 0x20, 
  };
  APPLY_PATCH(34);

  uint32_t patch35_addr = 0x00046060;
  uint8_t patch35_data[] = {
    0x54, 0x53, 0x43, 0x4F, 0x20, 0x4B, 0x20, 0x20, 0x20, 0x20, 0x33, 0x20, 0x2F, 0x20, 0x36, 0x20, 
  };
  APPLY_PATCH(35);

  uint32_t patch36_addr = 0x00046074;
  uint8_t patch36_data[] = {
    0x4F, 0x42, 0x42, 0x4D, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x33, 0x20, 0x2F, 0x20, 0x38, 0x20, 
  };
  APPLY_PATCH(36);

  uint32_t patch37_addr = 0x00046088;
  uint8_t patch37_data[] = {
    0x4F, 0x50, 0x45, 0x57, 0x55, 0x52, 0x20, 0x50, 0x20, 0x20, 0x30, 0x20, 0x2F, 0x20, 0x33, 0x20, 
  };
  APPLY_PATCH(37);

  uint32_t patch38_addr = 0x0004609C;
  uint8_t patch38_data[] = {
    0x49, 0x4D, 0x53, 0x53, 0x4C, 0x49, 0x20, 0x45, 0x20, 0x20, 0x30, 0x20, 0x2F, 0x20, 0x33, 0x20, 
  };
  APPLY_PATCH(38);

  uint32_t patch39_addr = 0x000460B0;
  uint8_t patch39_data[] = {
    0x4F, 0x42, 0x20, 0x4D, 0x41, 0x50, 0x54, 0x52, 0x20, 0x20, 0x30, 0x20, 0x2F, 0x20, 0x32, 0x20, 
  };
  APPLY_PATCH(39);

  uint32_t patch40_addr = 0x000460C4;
  uint8_t patch40_data[] = {
    0x48, 0x43, 0x49, 0x41, 0x20, 0x4E, 0x20, 0x20, 0x20, 0x20, 0x30, 0x20, 0x2F, 0x20, 0x43, 0x20, 
  };
  APPLY_PATCH(40);

  uint32_t patch41_addr = 0x000460D8;
  uint8_t patch41_data[] = {
    0x41, 0x52, 0x4B, 0x4E, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x30, 0x20, 0x2F, 0x20, 0x46, 0x20, 
  };
  APPLY_PATCH(41);

  uint32_t patch42_addr = 0x000460EC;
  uint8_t patch42_data[] = {
    0x4E, 0x49, 
  };
  APPLY_PATCH(42);

  uint32_t patch43_addr = 0x000460EF;
  uint8_t patch43_data[] = {
    0x46, 0x20, 0x20, 0x52, 0x50, 0x43, 0x41, 0x49, 0x54, 0x45, 0x43, 0x56, 0x20, 0x52, 0x45, 0x20, 
    0x2E, 
  };
  APPLY_PATCH(43);

  uint32_t patch44_addr = 0x00046101;
  uint8_t patch44_data[] = {
    0x20, 
  };
  APPLY_PATCH(44);

  uint32_t patch45_addr = 0x00046104;
  uint8_t patch45_data[] = {
    0x19, 0x10, 0xC0, 0x30, 0x19, 0x10, 0xFA, 0x66, 0x75, 0x4E, 
  };
  APPLY_PATCH(45);

  uint32_t patch46_addr = 0x00046110;
  uint8_t patch46_data[] = {
    0xB9, 0x4E, 
  };
  APPLY_PATCH(46);

  uint32_t patch47_addr = 0x00046114;
  uint8_t patch47_data[] = {
    0xCA, 0xAE, 0xB9, 0x4E, 
  };
  APPLY_PATCH(47);

  uint32_t patch48_addr = 0x0004611A;
  uint8_t patch48_data[] = {
    0xD0, 0xB2, 0x3C, 0x30, 
  };
  APPLY_PATCH(48);

  uint32_t patch49_addr = 0x00046120;
  uint8_t patch49_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(49);

  uint32_t patch50_addr = 0x00046124;
  uint8_t patch50_data[] = {
    0x50, 0x12, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(50);

  uint32_t patch51_addr = 0x0004612A;
  uint8_t patch51_data[] = {
    0xF0, 0x60, 0xF9, 0x4E, 0x04, 
  };
  APPLY_PATCH(51);

  uint32_t patch52_addr = 0x00046130;
  uint8_t patch52_data[] = {
    0x04, 0x61, 
  };
  APPLY_PATCH(52);

  uint32_t patch53_addr = 0x00046134;
  uint8_t patch53_data[] = {
    0x07, 
  };
  APPLY_PATCH(53);

  uint32_t patch54_addr = 0x00046136;
  uint8_t patch54_data[] = {
    0x06, 
  };
  APPLY_PATCH(54);

  uint32_t patch55_addr = 0x00046138;
  uint8_t patch55_data[] = {
    0x08, 
  };
  APPLY_PATCH(55);

  uint32_t patch56_addr = 0x0004613A;
  uint8_t patch56_data[] = {
    0x03, 
  };
  APPLY_PATCH(56);

  uint32_t patch57_addr = 0x0004613C;
  uint8_t patch57_data[] = {
    0x03, 
  };
  APPLY_PATCH(57);

  uint32_t patch58_addr = 0x0004613E;
  uint8_t patch58_data[] = {
    0x02, 
  };
  APPLY_PATCH(58);

  uint32_t patch59_addr = 0x00046140;
  uint8_t patch59_data[] = {
    0x0C, 
  };
  APPLY_PATCH(59);

  uint32_t patch60_addr = 0x00046142;
  uint8_t patch60_data[] = {
    0x0F, 
  };
  APPLY_PATCH(60);

  uint32_t patch61_addr = 0x00046144;
  uint8_t patch61_data[] = {
    0x3C, 0x30, 
  };
  APPLY_PATCH(61);

  uint32_t patch62_addr = 0x00046148;
  uint8_t patch62_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(62);

  uint32_t patch63_addr = 0x0004614C;
  uint8_t patch63_data[] = {
    0xD0, 0x12, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(63);

  uint32_t patch64_addr = 0x00046152;
  uint8_t patch64_data[] = {
    0x4C, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(64);

  uint32_t patch65_addr = 0x00046158;
  uint8_t patch65_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(65);

  uint32_t patch66_addr = 0x0004615E;
  uint8_t patch66_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(66);

  uint32_t patch67_addr = 0x00046162;
  uint8_t patch67_data[] = {
    0x90, 0x12, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(67);

  uint32_t patch68_addr = 0x00046168;
  uint8_t patch68_data[] = {
    0x60, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(68);

  uint32_t patch69_addr = 0x0004616E;
  uint8_t patch69_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(69);

  uint32_t patch70_addr = 0x00046174;
  uint8_t patch70_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(70);

  uint32_t patch71_addr = 0x00046178;
  uint8_t patch71_data[] = {
    0x50, 0x12, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(71);

  uint32_t patch72_addr = 0x0004617E;
  uint8_t patch72_data[] = {
    0x74, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(72);

  uint32_t patch73_addr = 0x00046184;
  uint8_t patch73_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(73);

  uint32_t patch74_addr = 0x0004618A;
  uint8_t patch74_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(74);

  uint32_t patch75_addr = 0x0004618E;
  uint8_t patch75_data[] = {
    0x10, 0x12, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(75);

  uint32_t patch76_addr = 0x00046194;
  uint8_t patch76_data[] = {
    0x88, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(76);

  uint32_t patch77_addr = 0x0004619A;
  uint8_t patch77_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(77);

  uint32_t patch78_addr = 0x000461A0;
  uint8_t patch78_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(78);

  uint32_t patch79_addr = 0x000461A4;
  uint8_t patch79_data[] = {
    0xD0, 0x11, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(79);

  uint32_t patch80_addr = 0x000461AA;
  uint8_t patch80_data[] = {
    0x9C, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(80);

  uint32_t patch81_addr = 0x000461B0;
  uint8_t patch81_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(81);

  uint32_t patch82_addr = 0x000461B6;
  uint8_t patch82_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(82);

  uint32_t patch83_addr = 0x000461BA;
  uint8_t patch83_data[] = {
    0x90, 0x11, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(83);

  uint32_t patch84_addr = 0x000461C0;
  uint8_t patch84_data[] = {
    0xB0, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(84);

  uint32_t patch85_addr = 0x000461C6;
  uint8_t patch85_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(85);

  uint32_t patch86_addr = 0x000461CC;
  uint8_t patch86_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(86);

  uint32_t patch87_addr = 0x000461D0;
  uint8_t patch87_data[] = {
    0x50, 0x11, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(87);

  uint32_t patch88_addr = 0x000461D6;
  uint8_t patch88_data[] = {
    0xC4, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(88);

  uint32_t patch89_addr = 0x000461DC;
  uint8_t patch89_data[] = {
    0x04, 0x61, 0x3C, 0x30, 
  };
  APPLY_PATCH(89);

  uint32_t patch90_addr = 0x000461E2;
  uint8_t patch90_data[] = {
    0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(90);

  uint32_t patch91_addr = 0x000461E6;
  uint8_t patch91_data[] = {
    0x10, 0x11, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(91);

  uint32_t patch92_addr = 0x000461EC;
  uint8_t patch92_data[] = {
    0xD8, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(92);

  uint32_t patch93_addr = 0x000461F2;
  uint8_t patch93_data[] = {
    0x04, 0x61, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(93);

  uint32_t patch94_addr = 0x000461F8;
  uint8_t patch94_data[] = {
    0xEC, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(94);

  uint32_t patch95_addr = 0x000461FE;
  uint8_t patch95_data[] = {
    0xD0, 0xFF, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(95);

  uint32_t patch96_addr = 0x00046204;
  uint8_t patch96_data[] = {
    0x02, 0x90, 0x1F, 
  };
  APPLY_PATCH(96);

  uint32_t patch97_addr = 0x00046208;
  uint8_t patch97_data[] = {
    0xD2, 0xFF, 0xFC, 0x33, 0x03, 
  };
  APPLY_PATCH(97);

  uint32_t patch98_addr = 0x0004620E;
  uint8_t patch98_data[] = {
    0x1F, 
  };
  APPLY_PATCH(98);

  uint32_t patch99_addr = 0x00046210;
  uint8_t patch99_data[] = {
    0xD4, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(99);

  uint32_t patch100_addr = 0x00046216;
  uint8_t patch100_data[] = {
    0xD6, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(100);

  uint32_t patch101_addr = 0x0004621C;
  uint8_t patch101_data[] = {
    0xD8, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(101);

  uint32_t patch102_addr = 0x00046222;
  uint8_t patch102_data[] = {
    0xDA, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(102);

  uint32_t patch103_addr = 0x00046228;
  uint8_t patch103_data[] = {
    0xDC, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(103);

  uint32_t patch104_addr = 0x0004622E;
  uint8_t patch104_data[] = {
    0xDE, 0xFF, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(104);

  uint32_t patch105_addr = 0x00046234;
  uint8_t patch105_data[] = {
    0xEE, 0xFF, 0x75, 0x4E, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(105);

  uint32_t patch106_addr = 0x0004623C;
  uint8_t patch106_data[] = {
    0xD0, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(106);

  uint32_t patch107_addr = 0x00046242;
  uint8_t patch107_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(107);

  uint32_t patch108_addr = 0x00046247;
  uint8_t patch108_data[] = {
    0x70, 0x40, 0x06, 0x01, 
  };
  APPLY_PATCH(108);

  uint32_t patch109_addr = 0x0004624C;
  uint8_t patch109_data[] = {
    0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(109);

  uint32_t patch110_addr = 0x00046250;
  uint8_t patch110_data[] = {
    0xE6, 0x12, 0x3C, 0x30, 0x20, 
  };
  APPLY_PATCH(110);

  uint32_t patch111_addr = 0x00046256;
  uint8_t patch111_data[] = {
    0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(111);

  uint32_t patch112_addr = 0x0004625A;
  uint8_t patch112_data[] = {
    0xA4, 0x12, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(112);

  uint32_t patch113_addr = 0x00046260;
  uint8_t patch113_data[] = {
    0xA8, 0x12, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(113);

  uint32_t patch114_addr = 0x00046266;
  uint8_t patch114_data[] = {
    0xD2, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(114);

  uint32_t patch115_addr = 0x0004626C;
  uint8_t patch115_data[] = {
    0x18, 0x66, 0x3C, 0x30, 
  };
  APPLY_PATCH(115);

  uint32_t patch116_addr = 0x00046271;
  uint8_t patch116_data[] = {
    0x70, 0x7C, 0x20, 0x17, 
  };
  APPLY_PATCH(116);

  uint32_t patch117_addr = 0x00046276;
  uint8_t patch117_data[] = {
    0xA4, 0x12, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(117);

  uint32_t patch118_addr = 0x0004627C;
  uint8_t patch118_data[] = {
    0xEC, 0x60, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(118);

  uint32_t patch119_addr = 0x00046282;
  uint8_t patch119_data[] = {
    0x04, 0x61, 0x12, 0x60, 0x39, 0xB0, 0x1F, 
  };
  APPLY_PATCH(119);

  uint32_t patch120_addr = 0x0004628A;
  uint8_t patch120_data[] = {
    0x03, 0x90, 0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(120);

  uint32_t patch121_addr = 0x00046291;
  uint8_t patch121_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(121);

  uint32_t patch122_addr = 0x00046296;
  uint8_t patch122_data[] = {
    0xA6, 0x12, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(122);

  uint32_t patch123_addr = 0x0004629C;
  uint8_t patch123_data[] = {
    0xD4, 0xFF, 0x40, 0x0C, 0x03, 
  };
  APPLY_PATCH(123);

  uint32_t patch124_addr = 0x000462A2;
  uint8_t patch124_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(124);

  uint32_t patch125_addr = 0x000462A7;
  uint8_t patch125_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(125);

  uint32_t patch126_addr = 0x000462AC;
  uint8_t patch126_data[] = {
    0x66, 0x12, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(126);

  uint32_t patch127_addr = 0x000462B2;
  uint8_t patch127_data[] = {
    0xD6, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(127);

  uint32_t patch128_addr = 0x000462B8;
  uint8_t patch128_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(128);

  uint32_t patch129_addr = 0x000462BD;
  uint8_t patch129_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(129);

  uint32_t patch130_addr = 0x000462C2;
  uint8_t patch130_data[] = {
    0x26, 0x12, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(130);

  uint32_t patch131_addr = 0x000462C8;
  uint8_t patch131_data[] = {
    0xD8, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(131);

  uint32_t patch132_addr = 0x000462CE;
  uint8_t patch132_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(132);

  uint32_t patch133_addr = 0x000462D3;
  uint8_t patch133_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(133);

  uint32_t patch134_addr = 0x000462D8;
  uint8_t patch134_data[] = {
    0xE6, 0x11, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(134);

  uint32_t patch135_addr = 0x000462DE;
  uint8_t patch135_data[] = {
    0xDA, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(135);

  uint32_t patch136_addr = 0x000462E4;
  uint8_t patch136_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(136);

  uint32_t patch137_addr = 0x000462E9;
  uint8_t patch137_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(137);

  uint32_t patch138_addr = 0x000462EE;
  uint8_t patch138_data[] = {
    0xA6, 0x11, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(138);

  uint32_t patch139_addr = 0x000462F4;
  uint8_t patch139_data[] = {
    0xDC, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(139);

  uint32_t patch140_addr = 0x000462FA;
  uint8_t patch140_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(140);

  uint32_t patch141_addr = 0x000462FF;
  uint8_t patch141_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(141);

  uint32_t patch142_addr = 0x00046304;
  uint8_t patch142_data[] = {
    0x66, 0x11, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(142);

  uint32_t patch143_addr = 0x0004630A;
  uint8_t patch143_data[] = {
    0xDE, 0xFF, 0x40, 0x0C, 
  };
  APPLY_PATCH(143);

  uint32_t patch144_addr = 0x00046310;
  uint8_t patch144_data[] = {
    0x04, 0x67, 0x40, 0x06, 
  };
  APPLY_PATCH(144);

  uint32_t patch145_addr = 0x00046315;
  uint8_t patch145_data[] = {
    0x70, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(145);

  uint32_t patch146_addr = 0x0004631A;
  uint8_t patch146_data[] = {
    0x26, 0x11, 0x3C, 0x30, 0x20, 
  };
  APPLY_PATCH(146);

  uint32_t patch147_addr = 0x00046320;
  uint8_t patch147_data[] = {
    0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(147);

  uint32_t patch148_addr = 0x00046324;
  uint8_t patch148_data[] = {
    0xCE, 0x12, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(148);

  uint32_t patch149_addr = 0x0004632A;
  uint8_t patch149_data[] = {
    0x8E, 0x12, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(149);

  uint32_t patch150_addr = 0x00046330;
  uint8_t patch150_data[] = {
    0x4E, 0x12, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(150);

  uint32_t patch151_addr = 0x00046336;
  uint8_t patch151_data[] = {
    0x0E, 0x12, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(151);

  uint32_t patch152_addr = 0x0004633C;
  uint8_t patch152_data[] = {
    0xCE, 0x11, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(152);

  uint32_t patch153_addr = 0x00046342;
  uint8_t patch153_data[] = {
    0x8E, 0x11, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(153);

  uint32_t patch154_addr = 0x00046348;
  uint8_t patch154_data[] = {
    0x4E, 0x11, 0xC0, 0x33, 0x17, 
  };
  APPLY_PATCH(154);

  uint32_t patch155_addr = 0x0004634E;
  uint8_t patch155_data[] = {
    0x0E, 0x11, 0xF9, 0x41, 0x17, 
  };
  APPLY_PATCH(155);

  uint32_t patch156_addr = 0x00046354;
  uint8_t patch156_data[] = {
    0xCE, 0x12, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(156);

  uint32_t patch157_addr = 0x0004635A;
  uint8_t patch157_data[] = {
    0xEC, 0xFF, 0x48, 0xED, 0xC0, 0x90, 0x3C, 0x30, 0x2A, 
  };
  APPLY_PATCH(157);

  uint32_t patch158_addr = 0x00046364;
  uint8_t patch158_data[] = {
    0x80, 0x30, 0x75, 0x4E, 0x47, 0x48, 0x07, 0x3C, 0x4E, 0xE0, 0x46, 0x8E, 0x07, 0x3C, 0x39, 0x30, 
    0x1F, 
  };
  APPLY_PATCH(158);

  uint32_t patch159_addr = 0x00046376;
  uint8_t patch159_data[] = {
    0xEE, 0xFF, 0x47, 0xB1, 0x46, 0xCE, 0xC6, 0x33, 0x1F, 
  };
  APPLY_PATCH(159);

  uint32_t patch160_addr = 0x00046380;
  uint8_t patch160_data[] = {
    0xEE, 0xFF, 0x07, 0x3C, 0x47, 0x02, 0x0C, 
  };
  APPLY_PATCH(160);

  uint32_t patch161_addr = 0x00046388;
  uint8_t patch161_data[] = {
    0x0A, 0x66, 0x06, 0x3E, 0x47, 0x02, 0x03, 
  };
  APPLY_PATCH(161);

  uint32_t patch162_addr = 0x00046390;
  uint8_t patch162_data[] = {
    0x36, 0x66, 0x75, 0x4E, 0x06, 0x3E, 0x07, 0x08, 0x03, 
  };
  APPLY_PATCH(162);

  uint32_t patch163_addr = 0x0004639A;
  uint8_t patch163_data[] = {
    0x14, 0x67, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(163);

  uint32_t patch164_addr = 0x000463A0;
  uint8_t patch164_data[] = {
    0xEC, 0xFF, 0x40, 0x53, 0x02, 0x64, 0x07, 0x70, 0xC0, 0x33, 0x1F, 
  };
  APPLY_PATCH(164);

  uint32_t patch165_addr = 0x000463AC;
  uint8_t patch165_data[] = {
    0xEC, 0xFF, 0x75, 0x4E, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(165);

  uint32_t patch166_addr = 0x000463B4;
  uint8_t patch166_data[] = {
    0xEC, 0xFF, 0x40, 0x52, 0x40, 0x0C, 0x08, 
  };
  APPLY_PATCH(166);

  uint32_t patch167_addr = 0x000463BC;
  uint8_t patch167_data[] = {
    0x02, 0x66, 
  };
  APPLY_PATCH(167);

  uint32_t patch168_addr = 0x000463BF;
  uint8_t patch168_data[] = {
    0x70, 0xC0, 0x33, 0x1F, 
  };
  APPLY_PATCH(168);

  uint32_t patch169_addr = 0x000463C4;
  uint8_t patch169_data[] = {
    0xEC, 0xFF, 0x75, 0x4E, 0xF9, 0x41, 0x1F, 
  };
  APPLY_PATCH(169);

  uint32_t patch170_addr = 0x000463CC;
  uint8_t patch170_data[] = {
    0xD0, 0xFF, 0xF9, 0x43, 0x04, 
  };
  APPLY_PATCH(170);

  uint32_t patch171_addr = 0x000463D2;
  uint8_t patch171_data[] = {
    0x34, 0x61, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(171);

  uint32_t patch172_addr = 0x000463D8;
  uint8_t patch172_data[] = {
    0xEC, 0xFF, 0x40, 0xD0, 0xF0, 0x41, 
  };
  APPLY_PATCH(172);

  uint32_t patch173_addr = 0x000463E0;
  uint8_t patch173_data[] = {
    0x06, 0x3E, 0x07, 0x08, 
  };
  APPLY_PATCH(173);

  uint32_t patch174_addr = 0x000463E6;
  uint8_t patch174_data[] = {
    0x10, 0x67, 0x10, 0x32, 0x71, 0xB2, 
  };
  APPLY_PATCH(174);

  uint32_t patch175_addr = 0x000463EE;
  uint8_t patch175_data[] = {
    0x04, 0x67, 0x50, 0x52, 0x75, 0x4E, 0x50, 0x42, 0x75, 0x4E, 0x10, 0x32, 0x04, 0x67, 0x50, 0x53, 
    0x75, 0x4E, 0xB1, 0x30, 
  };
  APPLY_PATCH(175);

  uint32_t patch176_addr = 0x00046404;
  uint8_t patch176_data[] = {
    0x75, 0x4E, 
  };
  APPLY_PATCH(176);

  uint32_t patch177_addr = 0x00046408;
  uint8_t patch177_data[] = {
    0xB9, 0x4E, 
  };
  APPLY_PATCH(177);

  uint32_t patch178_addr = 0x0004640C;
  uint8_t patch178_data[] = {
    0x08, 0xB5, 0xB9, 0x4E, 
  };
  APPLY_PATCH(178);

  uint32_t patch179_addr = 0x00046412;
  uint8_t patch179_data[] = {
    0x4C, 0xB4, 0x39, 0x08, 0x03, 
  };
  APPLY_PATCH(179);

  uint32_t patch180_addr = 0x00046418;
  uint8_t patch180_data[] = {
    0x10, 
  };
  APPLY_PATCH(180);

  uint32_t patch181_addr = 0x0004641A;
  uint8_t patch181_data[] = {
    0x09, 
  };
  APPLY_PATCH(181);

  uint32_t patch182_addr = 0x0004641C;
  uint8_t patch182_data[] = {
    0x02, 0x66, 0x75, 0x4E, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(182);

  uint32_t patch183_addr = 0x00046424;
  uint8_t patch183_data[] = {
    0x44, 0x61, 0xB9, 0x4E, 
  };
  APPLY_PATCH(183);

  uint32_t patch184_addr = 0x0004642A;
  uint8_t patch184_data[] = {
    0xCA, 0xAE, 0xB9, 0x4E, 
  };
  APPLY_PATCH(184);

  uint32_t patch185_addr = 0x00046430;
  uint8_t patch185_data[] = {
    0x9E, 0xCA, 0xB9, 0x4E, 
  };
  APPLY_PATCH(185);

  uint32_t patch186_addr = 0x00046436;
  uint8_t patch186_data[] = {
    0xC0, 0xCB, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(186);

  uint32_t patch187_addr = 0x0004643C;
  uint8_t patch187_data[] = {
    0x38, 0x62, 0xB9, 0x4E, 
  };
  APPLY_PATCH(187);

  uint32_t patch188_addr = 0x00046442;
  uint8_t patch188_data[] = {
    0x4A, 0xBF, 0x07, 0x3F, 0xB9, 0x4E, 0x04, 
  };
  APPLY_PATCH(188);

  uint32_t patch189_addr = 0x0004644A;
  uint8_t patch189_data[] = {
    0x68, 0x63, 0x1F, 0x3E, 0x79, 0x4A, 0x1F, 
  };
  APPLY_PATCH(189);

  uint32_t patch190_addr = 0x00046452;
  uint8_t patch190_data[] = {
    0x0C, 0x90, 0xD0, 0x67, 0x47, 0x02, 0x18, 
  };
  APPLY_PATCH(190);

  uint32_t patch191_addr = 0x0004645A;
  uint8_t patch191_data[] = {
    0xCA, 0x67, 0x07, 0x08, 0x04, 
  };
  APPLY_PATCH(191);

  uint32_t patch192_addr = 0x00046460;
  uint8_t patch192_data[] = {
    0x20, 0x67, 0xF9, 0x08, 
  };
  APPLY_PATCH(192);

  uint32_t patch193_addr = 0x00046466;
  uint8_t patch193_data[] = {
    0x1F, 
  };
  APPLY_PATCH(193);

  uint32_t patch194_addr = 0x00046469;
  uint8_t patch194_data[] = {
    0x90, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(194);

  uint32_t patch195_addr = 0x0004646E;
  uint8_t patch195_data[] = {
    0xD2, 0xFF, 0x1F, 
  };
  APPLY_PATCH(195);

  uint32_t patch196_addr = 0x00046472;
  uint8_t patch196_data[] = {
    0x28, 0x7E, 0xF9, 0x08, 
  };
  APPLY_PATCH(196);

  uint32_t patch197_addr = 0x00046478;
  uint8_t patch197_data[] = {
    0x1F, 
  };
  APPLY_PATCH(197);

  uint32_t patch198_addr = 0x0004647A;
  uint8_t patch198_data[] = {
    0x2A, 0x90, 0x79, 0x53, 0x1F, 
  };
  APPLY_PATCH(198);

  uint32_t patch199_addr = 0x00046480;
  uint8_t patch199_data[] = {
    0x0C, 0x90, 0x79, 0x4A, 0x1F, 
  };
  APPLY_PATCH(199);

  uint32_t patch200_addr = 0x00046486;
  uint8_t patch200_data[] = {
    0x0C, 0x90, 0x04, 0x67, 0x07, 0x08, 0x03, 
  };
  APPLY_PATCH(200);

  uint32_t patch201_addr = 0x0004648E;
  uint8_t patch201_data[] = {
    0x20, 0x67, 0xF9, 0x08, 0x01, 
  };
  APPLY_PATCH(201);

  uint32_t patch202_addr = 0x00046494;
  uint8_t patch202_data[] = {
    0x1F, 
  };
  APPLY_PATCH(202);

  uint32_t patch203_addr = 0x00046497;
  uint8_t patch203_data[] = {
    0x90, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(203);

  uint32_t patch204_addr = 0x0004649C;
  uint8_t patch204_data[] = {
    0xD2, 0xFF, 0x1F, 
  };
  APPLY_PATCH(204);

  uint32_t patch205_addr = 0x000464A0;
  uint8_t patch205_data[] = {
    0x28, 0x7F, 0xF9, 0x08, 0x01, 
  };
  APPLY_PATCH(205);

  uint32_t patch206_addr = 0x000464A6;
  uint8_t patch206_data[] = {
    0x1F, 
  };
  APPLY_PATCH(206);

  uint32_t patch207_addr = 0x000464A8;
  uint8_t patch207_data[] = {
    0x2A, 0x90, 0x79, 0x53, 0x1F, 
  };
  APPLY_PATCH(207);

  uint32_t patch208_addr = 0x000464AE;
  uint8_t patch208_data[] = {
    0x0C, 0x90, 0xB9, 0x4E, 
  };
  APPLY_PATCH(208);

  uint32_t patch209_addr = 0x000464B4;
  uint8_t patch209_data[] = {
    0xF8, 0xB2, 0xF9, 0x08, 0x07, 
  };
  APPLY_PATCH(209);

  uint32_t patch210_addr = 0x000464BA;
  uint8_t patch210_data[] = {
    0x1F, 
  };
  APPLY_PATCH(210);

  uint32_t patch211_addr = 0x000464BD;
  uint8_t patch211_data[] = {
    0x90, 
  };
  APPLY_PATCH(211);

  uint32_t patch212_addr = 0x000464BF;
  uint8_t patch212_data[] = {
    0x7E, 0xC7, 0x23, 0x1F, 
  };
  APPLY_PATCH(212);

  uint32_t patch213_addr = 0x000464C4;
  uint8_t patch213_data[] = {
    0x64, 0x90, 0xC7, 0x23, 0x1F, 
  };
  APPLY_PATCH(213);

  uint32_t patch214_addr = 0x000464CA;
  uint8_t patch214_data[] = {
    0x68, 0x90, 0xB9, 0x42, 0x1F, 
  };
  APPLY_PATCH(214);

  uint32_t patch215_addr = 0x000464D0;
  uint8_t patch215_data[] = {
    0xAC, 0x7F, 0xB9, 0x42, 0x1F, 
  };
  APPLY_PATCH(215);

  uint32_t patch216_addr = 0x000464D6;
  uint8_t patch216_data[] = {
    0xAC, 0x7E, 0xB9, 0x42, 0x1F, 
  };
  APPLY_PATCH(216);

  uint32_t patch217_addr = 0x000464DC;
  uint8_t patch217_data[] = {
    0x30, 0x90, 0xB9, 0x42, 0x1F, 
  };
  APPLY_PATCH(217);

  uint32_t patch218_addr = 0x000464E2;
  uint8_t patch218_data[] = {
    0x34, 0x90, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(218);

  uint32_t patch219_addr = 0x000464E8;
  uint8_t patch219_data[] = {
    0x12, 0x91, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(219);

  uint32_t patch220_addr = 0x000464EE;
  uint8_t patch220_data[] = {
    0x4E, 0x91, 0x39, 0x30, 0x1F, 
  };
  APPLY_PATCH(220);

  uint32_t patch221_addr = 0x000464F4;
  uint8_t patch221_data[] = {
    0xBE, 0x90, 0x40, 0xD0, 0xF9, 0x4B, 0x01, 
  };
  APPLY_PATCH(221);

  uint32_t patch222_addr = 0x000464FC;
  uint8_t patch222_data[] = {
    0x50, 0xC1, 0xF5, 0x33, 
  };
  APPLY_PATCH(222);

  uint32_t patch223_addr = 0x00046502;
  uint8_t patch223_data[] = {
    0x1F, 
  };
  APPLY_PATCH(223);

  uint32_t patch224_addr = 0x00046504;
  uint8_t patch224_data[] = {
    0x4C, 0x91, 0x79, 0x42, 0x1F, 
  };
  APPLY_PATCH(224);

  uint32_t patch225_addr = 0x0004650A;
  uint8_t patch225_data[] = {
    0x12, 0x91, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(225);

  uint32_t patch226_addr = 0x00046510;
  uint8_t patch226_data[] = {
    0xD0, 0xFF, 0x1F, 
  };
  APPLY_PATCH(226);

  uint32_t patch227_addr = 0x00046514;
  uint8_t patch227_data[] = {
    0x20, 0x90, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(227);

  uint32_t patch228_addr = 0x0004651A;
  uint8_t patch228_data[] = {
    0xD4, 0xFF, 0x1F, 
  };
  APPLY_PATCH(228);

  uint32_t patch229_addr = 0x0004651E;
  uint8_t patch229_data[] = {
    0x2E, 0x7F, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(229);

  uint32_t patch230_addr = 0x00046524;
  uint8_t patch230_data[] = {
    0xD4, 0xFF, 0x1F, 
  };
  APPLY_PATCH(230);

  uint32_t patch231_addr = 0x00046528;
  uint8_t patch231_data[] = {
    0x2E, 0x7E, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(231);

  uint32_t patch232_addr = 0x0004652E;
  uint8_t patch232_data[] = {
    0xD6, 0xFF, 0x1F, 
  };
  APPLY_PATCH(232);

  uint32_t patch233_addr = 0x00046532;
  uint8_t patch233_data[] = {
    0x30, 0x7F, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(233);

  uint32_t patch234_addr = 0x00046538;
  uint8_t patch234_data[] = {
    0xD6, 0xFF, 0x1F, 
  };
  APPLY_PATCH(234);

  uint32_t patch235_addr = 0x0004653C;
  uint8_t patch235_data[] = {
    0x30, 0x7E, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(235);

  uint32_t patch236_addr = 0x00046542;
  uint8_t patch236_data[] = {
    0xD8, 0xFF, 0x1F, 
  };
  APPLY_PATCH(236);

  uint32_t patch237_addr = 0x00046546;
  uint8_t patch237_data[] = {
    0x34, 0x7F, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(237);

  uint32_t patch238_addr = 0x0004654C;
  uint8_t patch238_data[] = {
    0xD8, 0xFF, 0x1F, 
  };
  APPLY_PATCH(238);

  uint32_t patch239_addr = 0x00046550;
  uint8_t patch239_data[] = {
    0x34, 0x7E, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(239);

  uint32_t patch240_addr = 0x00046556;
  uint8_t patch240_data[] = {
    0xDC, 0xFF, 0x1F, 
  };
  APPLY_PATCH(240);

  uint32_t patch241_addr = 0x0004655A;
  uint8_t patch241_data[] = {
    0x96, 0x7F, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(241);

  uint32_t patch242_addr = 0x00046560;
  uint8_t patch242_data[] = {
    0xDC, 0xFF, 0x1F, 
  };
  APPLY_PATCH(242);

  uint32_t patch243_addr = 0x00046564;
  uint8_t patch243_data[] = {
    0x96, 0x7E, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(243);

  uint32_t patch244_addr = 0x0004656A;
  uint8_t patch244_data[] = {
    0xDA, 0xFF, 0x1F, 
  };
  APPLY_PATCH(244);

  uint32_t patch245_addr = 0x0004656E;
  uint8_t patch245_data[] = {
    0x9C, 0x7F, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(245);

  uint32_t patch246_addr = 0x00046574;
  uint8_t patch246_data[] = {
    0xDA, 0xFF, 0x1F, 
  };
  APPLY_PATCH(246);

  uint32_t patch247_addr = 0x00046578;
  uint8_t patch247_data[] = {
    0x9C, 0x7E, 0xF9, 0x33, 0x1F, 
  };
  APPLY_PATCH(247);

  uint32_t patch248_addr = 0x0004657E;
  uint8_t patch248_data[] = {
    0xDE, 0xFF, 0x1F, 
  };
  APPLY_PATCH(248);

  uint32_t patch249_addr = 0x00046582;
  uint8_t patch249_data[] = {
    0x40, 0x90, 0xF9, 0x4E, 
  };
  APPLY_PATCH(249);

  uint32_t patch250_addr = 0x00046588;
  uint8_t patch250_data[] = {
    0xFE, 0x63, 
  };
  APPLY_PATCH(250);
}

void loadrom(int rom)
{
}

void patching(int rom)
{
  switch(rom) {
    case 0:
      patch_6rom();
      break;
    default:
      fprintf(stderr, "Bad patch ROM ID %d\n", rom);
      break;
  }
}

void saverom(int rom)
{
}

